;       Static Name Aliases
;
	TITLE   psll2.asm
;
;     hergestellt aus muster1.c
;
	 .8087
	    include cmacros.inc

INCLUDELIB      SLIBCE
_TEXT   SEGMENT  WORD PUBLIC 'CODE'
_TEXT   ENDS
_DATA   SEGMENT  WORD PUBLIC 'DATA'
dseg32        dw 0
sseg16        dw 0
sptr16        dw 0
sseg32        dw 0
sptr32_lo     dw 0
sptr32_hi     dw 0
chandel       dw 0
sptr16x       dw 0
    public _error_code
_error_code   dw 0    ; transfer of interrupt number
    public _code_seg
_code_seg     dw 0
    public _error_seg
_error_seg    dw 0
    public _error_adr
_error_adr    dw 0
    public _error_sptr
_error_sptr   dw 0
    public _code32_seg
_code32_seg   dw 0

      ;; 32 bit entry point address
U32EntryPt       LABEL FWORD   
globalD          U32EntOff,0h
globalW          U32CodeSel,0
text   db   "Hier bin ich",10,13,"$"

_DATA   ENDS
CONST   SEGMENT  WORD PUBLIC 'CONST'
CONST   ENDS
_BSS    SEGMENT  WORD PUBLIC 'BSS'
_BSS    ENDS
DGROUP  GROUP   CONST, _BSS, _DATA
	ASSUME DS: DGROUP, SS: DGROUP
;                                        EXTRN   _init32:FAR
EXTRN   _psll_call:NEAR
_BSS      SEGMENT
;
;   construct entry to 32 bit code by combining an offset (=0)
;   and a 32 bit code segment selector
;
COMM NEAR       _init32:  BYTE:    4
;
COMM NEAR       PLOCALHEAP:     BYTE:    2
_BSS      ENDS
_TEXT      SEGMENT  
ASSUME  CS: _TEXT
assume  ds: _DATA
; Line 1
; Line 3
; Line 14
	PUBLIC  _psl_init
_psl_init       PROC NEAR
	push    bp
	mov     bp,sp
	mov     ax,sp
	mov     WORD PTR sptr16,ax
	mov     ax,ss
	mov     WORD PTR sseg16,ax
	     ; the 32 bit stack pointer (upper limit - 4)
	mov     ax, WORD PTR [bp+10]
	sub     ax,4
	mov     WORD PTR [sptr32_hi],ax
	mov     ax,WORD PTR [bp+8] 
	mov     WORD PTR [sptr32_lo],ax

;       mode= 20
;       env = 18
;       c32 = 16
;       s32 = 14
;       d32 = 12
;       stacksize = 8
;       heapsize = 4
;                                          switch stack
	mov     ax,ss                    ; save ss temp in es
	mov     es,ax
	mov     ax,WORD PTR [bp+14]
	mov     WORD PTR sseg32,ax
	mov     ss,ax

	mov     ax,WORD PTR es:[bp+16]     ;c32
	mov     WORD PTR U32CodeSel,ax
	mov     ax,0
	mov     WORD PTR U32EntOff,ax
	mov     WORD PTR U32EntOff+2,ax

	db      66h      ; 32 bit
	sub     sp,sp
	mov     sp,600    ; vordere 16 bits jetzt sauber
	push    WORD PTR es:[bp+20]        ; mode
	push    WORD PTR es:[bp+18]        ; psp segment
	mov     ax,OFFSET _l16_main
	push    ax
	mov     ax,OFFSET _l16_call
	push    ax
	mov     ax,cs                   ; 16 bit code segment
	push    ax
	push    WORD PTR es:[bp+14]        ;s32
	push    WORD PTR es:[bp+12]        ;d32
	push    WORD PTR es:[bp+10]
	push    WORD PTR es:[bp+8] ;stacksize
	push    WORD PTR es:[bp+6]
	push    WORD PTR es:[bp+4] ;heapsize
;;;        call    [U32EntryPt]
	db      66h
	sub     ax,ax
	lea     ax,U32EntryPt
	db      66h             ; operand size prefix, causing 32 bit call
	db      67h             ; address size prefix
	db      255,18h

;                               switch stack and data back
	mov     bx,SEG _DATA
	mov     ds,bx
	mov     bx,WORD PTR sseg16
	mov     ss,bx
	mov     bx,Word PTR sptr16
	mov     sp,bx
	pop     bp
	ret     
_psl_init       ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; 32 bit routines calls for Windows main loop; this is logically
;     a return to 16 bit part

      ;  PUBLIC  _l16_main
_l16_main:
			  ; switch DS
	mov     ax,ds
	mov     bx,SEG _DATA
	mov     ds,bx
	mov     dseg32,ax
			  ; switch SS and SP
	mov     bp,sp
	mov     sptr32_lo,sp
	mov     ax,ss
	mov     sseg32,ax
	mov     es,ax
	mov     ax,sseg16
	mov     ss,ax
	mov     sp,WORD PTR sptr16
	   ; convert 1st parameter to return value
	mov     dx,WORD PTR es:[bp+10]
	mov     ax,WORD PTR es:[bp+8]         ;p1
	   ; return to 16 bit caller 

	pop      bp
	ret

 ;  windows main loop calls PSL program with fresh data
 ;     this is logically a return to 32 bits
 
      PUBLIC   _psl_input
_psl_input    PROC NEAR

	      ; save frame and stack pointers
       push   bp
       mov    sptr16,sp
       mov    bp,sp           

	      ; convert 1st parameter to return value
       mov   ax,WORD PTR ss:[bp+4]
       mov   dx,WORD PTR ss:[bp+6]
	      ; cx: message bits
       mov   cx,WORD PTR ss:[bp+8] 

	      ; switch stack to 32 bits
       mov     bx,sseg32
       mov     ss,bx
       db      66h
       sub     sp,sp
       mov     sp,sptr32_lo

       ;    push ax
       ;    mov ax,0200h
       ;    mov dl,35
       ;    int 21h
       ;    pop ax

	      ; switch ds back to 32 bits
       mov     bx,dseg32
       mov     ds,bx
    
       db      66h,67h     ; 32 bit prefix: long far return
       db      0cbh      

_psl_input     ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;   32 bit routine calls 16 bit module as conventional subroutine
;
;
      ;  PUBLIC  _l16_call
_l16_call:
			  ; switch DS
	mov     ax,ds
	mov     bx,SEG _DATA
	mov     ds,bx
	mov     dseg32,ax
			  ; switch SS and SP
	mov     bp,sp
	mov     sptr32_lo,sp
	mov     ax,ss
	mov     sseg32,ax
	mov     es,ax
	mov     ax,sseg16
	mov     ss,ax
	mov     sp,WORD PTR sptr16

;       p4 = 20
;       p3 = 16
;       p2 = 12
;       p1 = 8
;       p0 = 4

	push    WORD PTR es:[bp+22]
	push    WORD PTR es:[bp+20]        ;p4
	push    WORD PTR es:[bp+18]
	push    WORD PTR es:[bp+16]        ;p3
	push    WORD PTR es:[bp+14]
	push    WORD PTR es:[bp+12]        ;p2
	push    WORD PTR es:[bp+10]
	push    WORD PTR es:[bp+8]         ;p1
	
	call    _psll_call
			  ;; switch ss back
	
	mov     bx,sseg32
	mov     ss,bx
	db      66h           ; 32 bit
	sub     sp,sp         ; clear high bits of ESP
	mov     sp,sptr32_lo  ; reset stack pointer to old value
    
			  ;; switch ds back
	mov     bx,dseg32
	mov     ds,bx
    
	db      66h,67h     ; 32 bit prefix: long far return
	db      0cbh    ; far ret     

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; some utilities
    extrn DOS3Call : far
    
    PUBLIC _Wcwd
_Wcwd:                 ; /* change working directory */
       push  bp
       mov   bp,sp
       mov   dx,WORD ptr 4[bp]
       mov   ah,03bh
       cCall DOS3Call
       jc    cwdbad
       mov   ax,0
cwdbad:
       pop   bp
       ret
   
   PUBLIC _Wcdrv
_Wcdrv:                 ; /* change current drive */
       push  bp
       mov   bp,sp
       mov   dx,WORD ptr 4[bp]
       mov   ah,0eh
       cCall DOS3Call
       mov   ax,0
       pop   bp
       ret

    PUBLIC _Wgwd
_Wgwd:                 ; /* get working directory */
       push  bp
       mov   bp,sp
       mov   dl,0
       mov   si,WORD ptr 4[bp]
       mov   ah,047h
       cCall DOS3Call
       pop   bp
       ret
    
    PUBLIC _Wgdrv      ; get current drive
_Wgdrv:
       push bp
       mov  ah,19h
       cCall DOS3Call
       mov  ah,0
       pop  bp
       ret


    PUBLIC _Wdate
_Wdate:
       push  bp
       mov   bp,sp
       mov   ah,02ah
       cCall DOS3Call
       mov   es,WORD ptr 6[bp]
       mov   si,WORD ptr 4[bp]
       mov   WORD ptr es:[si],cx
       add   si,4
       mov   WORD ptr es:[si],dx
       pop   bp
       ret
    
    PUBLIC _Wtime
_Wtime:
       push  bp
       mov   bp,sp
       mov   ah,02ch
       cCall DOS3Call
       mov   es,WORD ptr 6[bp]
       mov   si,WORD ptr 4[bp]
       mov   WORD ptr es:[si],cx
       add   si,4
       mov   WORD ptr es:[si],dx
       pop   bp
       ret

    PUBLIC _lar
_lar:
       push  bp
       mov   bp,sp
       mov   ax,WORD ptr ss:[bp+4]
       
       db    66h,67h     ; 32 bit prefix:
       db    0fh,02h,0c0h    ; lar ax,ax
	
	;  shr   eax,8        ; shift eax 1 byte
       mov   cl,8
       db    66h,67h     ; 32 bit prefix:
       shr   ax,cl

       pop   bp
       ret


    PUBLIC _int31h
_int31h:
       push  bp
       mov   bp,sp
       mov   ax,ds
       mov   es,ax
       mov   si,WORD ptr ss:[bp+4]
       mov   ax,WORD ptr ds:[si]
       mov   bx,WORD ptr ds:[si+2]
       mov   cx,WORD ptr ds:[si+4]
       mov   dx,WORD ptr ds:[si+6]
			     ; skip si for the moment
       mov   di,WORD ptr ds:[si+10]
       mov   si,WORD ptr ds:[si+8]   
       push bp
       clc
       int   31h
       pop  bp
       push  si
       mov   si,WORD ptr ss:[bp+4]
       mov   WORD ptr ds:[si],ax
       mov   WORD ptr ds:[si+2],bx
       mov   WORD ptr ds:[si+4],cx
       mov   WORD ptr ds:[si+6],dx
       pop   ax
       mov   WORD ptr ds:[si+8],ax   ; si 
       mov   WORD ptr ds:[si+10],di
     jc    int31hbad
       mov   ax,0
       pop   bp
       ret
int31hbad:
       mov   ax,1
       pop   bp
       ret

	 ;
	 ;   install handler for exceptions (special convention for 
	 ;   interrupt stack handling)
	 ;
    PUBLIC _csignal
_csignal:
       push  bp
       mov   bp,sp
       mov   ax,0203h           
       mov   bx,WORD ptr 4[bp]  ; interrupt number
       mov   cx,cs              ; code segment
       mov   dx,WORD ptr 6[bp]  ; target address (C handler)
       mov   WORD ptr chandel,dx
       lea   dx,hseq
       add   dx,WORD ptr 8[bp]  ; offset in jmp table(multiple of 6) 
       int   31h
       jc    schlecht
       mov   ax,0
schlecht:       
       pop   bp
       ret

hseq:     mov ax,0
	  jmp handel
	  mov ax,1
	  jmp handel
	  mov ax,2
	  jmp handel
	  mov ax,3
	  jmp handel
	  mov ax,4
	  jmp handel
	  mov ax,5
	  jmp handel
	  mov ax,6
	  jmp handel
	  mov ax,7
	  jmp handel
	  mov ax,8
	  jmp handel
	  mov ax,9

handel:
	push bp
	mov  bp,sp
	push bx
	push ds
	mov  bx,SEG _DATA 
	mov  ds,bx
	   ; save error code
	mov WORD ptr _error_code,ax
	mov ax,WORD ptr U32CodeSel
	mov WORD ptr _code32_seg,ax

	      ; save modify return structure
	mov ax,WORD ptr ss:[bp+8]    ; error address
	mov WORD ptr _error_adr,ax
	lea ax,handelx
	mov WORD ptr ss:[bp+8],ax    ; "handelx" as return point
	
	mov ax,WORD ptr ss:[bp+10]   ;  save and overwrite error code seg
	mov WORD ptr _error_seg,ax
	mov ax,cs
	mov WORD ptr ss:[bp+10],ax   ;  this code segment
	mov WORD ptr _code_seg,ax
	
	mov ax,WORD ptr ss:[bp+14]   ; save and overwrite stack ptr
	mov WORD ptr _error_sptr,ax
	mov ax,WORD ptr sptr16
	sub ax,4
	mov word ptr ss:[bp+14],ax   ; old 16 bit stack pointer
	mov ax,word ptr sseg16
	mov word ptr ss:[bp+16],ax   ; 16 bit stack segment
		
		;  restore registers
	pop ds
	pop bx
	pop bp
	retf       ; far return

handelx:        
	mov  bx,SEG _DATA            ; fetch data segment again
	mov  ds,bx
	mov  bx,word ptr sseg16      ; and for safety restore stack again
	mov  ss,bx
	mov  bx,word ptr sptr16
	sub  bx,4
	mov  sp,bx
	
	mov  ax,_error_code          ; error code as argument
	push ax
	call [chandel]               ; rest to be done by C code

	;
	;   install handlers for interrupts: no special stack
	;
    PUBLIC _csignal2
_csignal2:
       push  bp
       mov   bp,sp
       mov   ax,0205h     
       mov   bx,WORD ptr 4[bp]  ; interrupt number
       mov   cx,cs              ; code segment
       mov   dx,WORD ptr 6[bp]  ; target address (C handler)
       mov   WORD ptr chandel,dx
       lea   dx,hseq2
       add   dx,WORD ptr 8[bp]  ; offset in jmp table(multiple of 6) 
       int   31h
       jc    schlecht2
       mov   ax,0
schlecht2:       
       pop   bp
       ret

hseq2:     mov ax,0
	  jmp handel2
	  mov ax,1
	  jmp handel2
	  mov ax,2
	  jmp handel2
	  mov ax,3
	  jmp handel2
	  mov ax,4
	  jmp handel2
	  mov ax,5
	  jmp handel2
	  mov ax,6
	  jmp handel2
	  mov ax,7
	  jmp handel2
	  mov ax,8
	  jmp handel2
	  mov ax,9

handel2:
	   ; save error code
	mov WORD ptr _error_code,ax
	mov  bx,SEG _DATA            ; fetch data segment
	mov  ds,bx
	
	mov  bp,sp
	mov bx,WORD ptr U32CodeSel
	mov WORD ptr _code32_seg,bx
	mov  bx,WORD ptr ss:[bp]
	mov  WORD ptr _error_adr,bx
	mov  bx,WORD ptr ss:[bp+2]
	mov  WORD ptr _error_seg,bx
	mov  WORD ptr _code_seg,cs
	mov  bx,word ptr sseg16      ; restore stack
	mov  ss,bx
	mov  bx,word ptr sptr16
	sub  bx,4
	mov  sp,bx
	
	   ; error code as argument
	push ax
	call [chandel]               ; rest to be done by C code


     PUBLIC _lisp_alarm      
_lisp_alarm:
	push    bp
	
	mov     bp,sp
	mov     cx,WORD ptr [bp+4]  ; true address of error handler
	mov     dx,WORD ptr [bp+6]
	mov     si,WORD ptr [bp+8]  ; error stack ptr
	mov     di,WORD ptr [bp+10] ; error address
	mov     bx,sseg32
	mov     ss,bx
	db      66h           ; 32 bit
	sub     sp,sp         ; clear high bits of ESP
	mov     sp,2000       ; stack pointer to some high value
			      ;; switch ds back
	mov     bx,dseg32
	mov     es,bx         ; in es for the moment (need ds for jump)

;;;        call    [U32EntryPt]     ; using the main entry point
	mov     bx,4712
	db      66h
	sub     ax,ax
	lea     ax,U32EntryPt
	db      66h             ; operand size prefix, causing 32 bit call
	db      67h             ; address size prefix
	db      255,18h


_TEXT   ENDS
END
