
(load vector-fix nbig0)

(de sys2fixn (n)
  (prog (fx)
        (setf savefixn-tag (tag n))
        (setf savefixn-inf (inf n))
        (setf n 0)
        (setq fx (gtfixn))
        (setf (fixval fx) (mkitem savefixn-tag savefixn-inf))
        (return (mkfixn fx))))

(de gcdn ( x y )
   (when (lessp y 0) (setq y (minus y)))
   (when (lessp x 0) (setq x (minus x)))
   (gcdn-aux  x y))

(de gcdn-aux ( x y ) % positive operands
   (cond ((eq 0 y) x)
         ((lessp x y) (gcdn-aux y x))
         (t (gcdn-aux y (remainder x y)))))
